// =================================================
// Alternate constructor function
function UIbutton(scene, x, y, key, overKey, label, scale, targetCallback){
	
	this.scene = scene; 	// the scene of this container?? necessary??
    this.x = x; 			// the x position 
    this.y = y; 			// the y position 
    this.key = key; 		// button background image preloaded key
    this.overKey = overKey; // button hover image or use spriteSheet frame
    this.label = label;		// button label from languages DB
	this.scale = scale;		// adjust button size
    this.targetCallback = targetCallback; // the callback function

    // create our User Interface Button
    this.createButton();	// private creation function
    // add this "container/group" to our Phaser III Scene
	// use containers for a "set of menu buttons" similar to
	// a Flahs MovieClip frame
    this.scene.add.existing(this);
	
	// -------------------------------------------
	// or just use this directly?!
	// createButton(x, y, key, overKey, label, scale, targetCallback){
	createButton() {
		// create a menu button background image or
		// sprite is animated
		this.button = this.add.image(x, y, key);
		// make image interactive
		this.button.setInteractive();
		// scale the button
		this.button.setScale(scale);

		// create the button text
		// button labels come from common language DB variables
		this.labelText = this.add.text(x, y, this.label, GAMEAPP.style??);
		this.labelText.setOrigin(.5,.5);	// default is top left
		this.labelText.setScale(scale);
		this.labelText.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
		
		// center the label text inside the UI button
		Phaser.Display.Align.In.Center(this.labelText, this.button);

		// add the two game components into a container? or group
		this.add(this.button);
		this.add(this.buttonText);

		// listen for events
		this.button.on('pointerdown', () => {
		  this.targetCallback();
		});

		this.button.on('pointerover', () => {
			// if separate image used
			this.button.setTexture(this.overKey);
			// if spriteSheet then move to frame
			//this.button.setFrame(? frame number ?);
		});

		this.button.on('pointerout', () => {
			// if separate image used
			this.button.setTexture(this.key);
			// if spriteSheet then move to frame
			//this.button.setFrame(? frame number ?);
		});
	}
	// -------------------------------------------
	// Add other supporting methods
	// - reserach JQuery UI components
	// - UI checkboxs and radio buttons 
	// -------------------------------------------
	

}

// =================================================
// from Code Pen: https://codepen.io/yandeu/pen/OdYdbp?editors=0010
// Also see: https://phasergames.com/how-to-make-buttons-in-phaser-3/
// -------------------------------------------
/**
class Button extends Phaser.GameObjects.Sprite {
	// only problem is this uses "FAT arrow" for methods
	onInputOver = () => {}
	onInputOut = () => {}
	onInputUp = () => {}

	constructor(scene, x, y, texture, actionOnClick = () => {}, overFrame, outFrame, downFrame) {
	super(scene, x, y, texture)
	scene.add.existing(this)

	this.setFrame(outFrame)
		.setInteractive()

		.on('pointerover', () => {
			this.onInputOver()
			this.setFrame(overFrame)
		})
		.on('pointerdown', () => {
			actionOnClick()
			this.setFrame(downFrame)
		})
		.on('pointerup', () => {
			this.onInputUp()
			this.setFrame(overFrame)
		})
		.on('pointerout', () => {
			this.onInputOut()
			this.setFrame(outFrame)
		})
	}
}


class MainScene extends Phaser.Scene {
  constructor() {
    super({ key: 'MainScene' })
  }

  preload() {
    this.load.setCORS('anonymous')
    this.load.spritesheet('button', 'https://examples.phaser.io/assets/buttons/button_sprite_sheet.png', { frameWidth: 193, frameHeight: 71 })
    this.load.atlas('buttonAtlas', 'https://examples.phaser.io/assets/buttons/button_texture_atlas.png', 'https://examples.phaser.io/assets/buttons/button_texture_atlas.json')
  }

  create() {
    const actionOnClick = () => {
      console.log('click')
    }
	// spriteSheet example
    let btn1 = new Button(this, 50, 50, 'button', actionOnClick, 2, 1, 0)
    btn1.onInputOut = () => {
      console.log('Btn1: onInputOut')
    }
    btn1.setOrigin(0)
	
	// texture atlas example
    let btn2 = new Button(this, 50, 150, 'buttonAtlas', actionOnClick, 'over', 'out', 'down')
    btn2.onInputOut = () => {
      console.log('Btn2: onInputOut')
    }
    btn2.setOrigin(0)
  }
}

var config = {
    type: Phaser.AUTO,
    scale: {
      mode: Phaser.Scale.FIT,
      autoCenter: Phaser.Scale.CENTER_BOTH,
      width: 400,
      height: 300
    },
    backgroundColor: '#ffffff',
    parent: 'phaser-example',
    scene: [MainScene]
};

var game = new Phaser.Game(config);

*/

// =================================================
// from Zenva MMORPG_1_CompleteProj
// -------------------------------------------
// Problems with containers: 
// - nested containers removed v3.14+
// - nested containers available pre-3.14 only
// See: William Clarkson solution for v3.14+
// https://phasergames.com/ui-blocks-a-lightweight-alternate-to-containers/
// -------------------------------------------
class UiButton extends Phaser.GameObjects.Container {
  constructor(scene, x, y, key, hoverKey, text, targetCallback) {
    super(scene, x, y);
    this.scene = scene; // the scene this container will be added to
    this.x = x; // the x position of our container
    this.y = y; // the y position of our container
    this.key = key; // the background image of our button
    this.hoverKey = hoverKey; // the image that will be displayed when the player hovers over the button
    this.text = text; // the text that will be displayed on the button
    this.targetCallback = targetCallback; // the callback function that will be called when the player clicks the button

    // create our Ui Button
    this.createButton();
    // add this container to our Phaser Scene
    this.scene.add.existing(this);
  }

  createButton() {
    // create play game button
    this.button = this.scene.add.image(0, 0, 'button1');
    // make button interactive
    this.button.setInteractive();
    // scale the button
    this.button.setScale(1.4);

    // create the button text
    this.buttonText = this.scene.add.text(0, 0, this.text, { fontSize: '26px', fill: '#fff' });
    // center the button text inside the Ui button
    Phaser.Display.Align.In.Center(this.buttonText, this.button);

    // add the two game objects to our container
    this.add(this.button);
    this.add(this.buttonText);

    // listen for events
    this.button.on('pointerdown', () => {
      this.targetCallback();
    });

    this.button.on('pointerover', () => {
      this.button.setTexture(this.hoverKey);
    });

    this.button.on('pointerout', () => {
      this.button.setTexture(this.key);
    });
  }

}
