/**
Copyright © 1997-2016, Stephen Gose LLC. All rights reserved.
Visit our game show case:	https://www.renown-games.com 
License information:		https://makingbrowsergames.com/starterkits/quiz/
Affiliate Information:		https://www.stephen-gose.com/affiliates-program

 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
 * THE SOFTWARE.
 * 
 *
	 * File Name: boot.js
	 * Live Demo: https://makingbrowsergames.com/starterkits/
	 * Source Code: https://makingbrowsergames.com/starterkits/
	 * Description: File for controlling initial game shell launch; managing global variables throughout game state.
	 * Author: Stephen Gose
	 * Version: 0.0.0.xxxx semver launch date
	 * Author URL: https://www.stephen-gose.com/
	 * Support: support@pbmcube.com
	 *
	 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
	 * 
	 * Do not sell! Do not distribute!
	 * This is a licensed permission file. Please refer to Terms of Use
	 *   and End Users License Agreement (EULA).
	 * Search for [ //**TODO** ] to tailor this file for your own use 
	 *   and will void any support agreement.
	 *
	 * Redistribution of part or whole of this file and
	 * the accompanying files is strictly prohibited.
	 *
	 */

	"use strict";
	
var boot = new Phaser.Class({

    Extends: Phaser.Scene,
    initialize: function boot () {
        Phaser.Scene.call(this, { key: 'boot' });
    },

		preload: function(){
			console.log("> %c  Game Prototype boot configure browser settings  ", "color:white; background:red");
			
			//Debug Plugin - for tutorials, development and books
			//this.game.add.plugin(Phaser.Plugin.Debug);
// -------------------------------------------
// TODO: Last chance to start WebSocket automatically!!
// -------------------------------------------			
//
// =================================================			
// CORS:
// - https://developer.mozilla.org/en-US/docs/Web/HTTP/Access_control_CORS
// - https://enable-cors.org/
// Avoid this anti-pattern of omitting the protocols schemes in script "src";
// Cross origin requests are only supported for protocol schemes: 
//		http, data, chrome, chrome-extension, https.
//			this.load.crossOrigin = 'anonymous';
//
// =================================================
		this.load.image('twitter', 'assets/twitter.png');
			// required assets for following states here	
			//<SKU> mainMenu & Story collapse into one scene
			this.load.path = "assets/images/staticScenes/";			
			this.load.image('background', 'titleScene.jpg');	
			this.load.image('creditScene', 'creditsScene.jpg');	
			this.load.image('langScene', 'languageScene.jpg');
			this.load.image('mainMenu', 'mainMenu.jpg');
			//this.load.image('menus', 'MenuPanelHUD2.jpg');
			this.load.image('storyScene', 'storyScene.jpg');
			this.load.image('titleScene', 'titleScene.jpg');
	/**
			//Language Scene uses StoryPanelHud
			this.load.path = "assets/images/flags/";
			this.load.spritesheet('chinaBtn', 'china.png', 50, 50);
			this.load.spritesheet('dmarkBtn', 'denmark.png', 50, 50);
			this.load.spritesheet('englishBtn', 'english.png', 50, 50);
			this.load.spritesheet('frenchBtn', 'france.png', 50, 50);
			this.load.spritesheet('germanBtn', 'germany.png', 50, 50);
			this.load.spritesheet('italyBtn', 'italy.png', 50, 50);
			this.load.spritesheet('japanBtn', 'japan.png', 50, 50);
			this.load.spritesheet('nlandBtn', 'netherlands.png', 50, 50);
			this.load.spritesheet('portugalBtn', 'portugal.png', 50, 50);
			this.load.spritesheet('spainBtn', 'spain.png', 50, 50);
			this.load.spritesheet('swedenBtn', 'sweden.png', 50, 50);
			
			//UI Buttons
			this.load.path = "";
			//this.load.spritesheet('button', 'assets/spriteSheets/mmog-sprites-silver.png', 129, 30);
			//this.load.atlas('button-continue','assets/spriteSheets/RightArrow-Phaser.png','assets/spriteSheets/arrowR-sprites.json');
			//this.load.atlas('button','assets/spriteSheets/mmog-sprites-silver.png','assets/spriteSheets/mmog-sprites.json');
			//this.load.atlas('langButton','assets/spriteSheets/language.png','assets/spriteSheets/language.json');
			
			//Load button for twitter
			this.load.image('twitter','assets/images/twitter.png');
	*/		
			// set world size
			
			// set the boundaries of our game world
			//this.physics.bounds.width = https://www.stephen-gose.com/affiliates-program.GAMEAPP.worldWidth;
			//this.physics.bounds.height = https://www.stephen-gose.com/affiliates-program.GAMEAPP.worldHeight;
			//this.game.setCollideWorldBounds(true);
			//this.enableScaling();
					
		},

		create: function(){
			//this.background = this.add.image(0, 0, 'background');

			//ACTIVATE FOR ITCH.IO BUILDS
			//local storage capacity = 5MB per
			//The localStorage object stores the data with no expiration date. 
			//The data will not be deleted when the browser is closed,
			//   and will be available whenever.
			if(localStorage.firstRunDate !== "undefined"){
				localStorage.clear();
				sessionStorage.clear();
			}else{
				console.log(" %c  Resorting to Cookie storage.","color:white; background:red");
			}
			
			//
			if(localStorage.firstRun != "DONE"){
				console.log(" %c  Setting up for first-time run  ","color:white; background:red");
				//firstRun();
			}
				
			// goto load state
			this.scene.start("load");
		}
    
});
