/**
Copyright © 1997-2016, Stephen Gose LLC. All rights reserved.
Visit our game show case:	https://www.renown-games.com 
License information:		https://shop.pbmcube.net/?s=xxxxxxx
Affiliate Information:		https://www.stephen-gose.com/affiliates-program

 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
 * THE SOFTWARE.
 * 
 *
 * File Name: play.js
 * Live Demo: https://makingbrowsergames.com/starterkits/match3/
 * Source Code: https://shop.pbmcube.net/
 * Description: File for controlling and displaying game scenes;
 *               managing global variables throughout game state.
 * Author: Stephen Gose
 * Version: 15.0.0.20091227  //semantic version: by (0.0.0.date-#)
 * Phaser Version: 3.24+
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
 * Redistribution of part or whole of this file and
 *   the accompanying files is strictly prohibited.
 * 
 *  This is a licensed file with EULA permission. 
 *  Do not sell! Do not distribute!  
 *  Please refer to the Terms of Use and 
 *    End Users License Agreement (EULA).
 *  https://shop.pbmcube.net/terms-of-use/ 
 *  
 * Search for "//**TODO**" to tailor this file for your production; 
 *	 doing so will void any support agreement.
 *
 */
 

// =========================================================
// Phaser III Game Framework:
// Exchange this code with other Gaming Frameworks?
// =========================================================
https://www.stephen-gose.com/affiliates-program.GAMEAPP.state.play = new Phaser.Class({
	// ---------------------------------------------------------
	// JavaScript doesn’t really have constructors, rather constructor "calls".
	// https://github.com/getify/You-Dont-Know-JS/blob/2nd-ed/objects-classes/ch5.md
    Extends: Phaser.Scene,

    initialize: function playGame (){
        Phaser.Scene.call(this, { key: 'play' });
    },

	// =========================================================
	// Phaser III Essential Functions
	// ---------------------------------------------------------
    preload(){
		//-----
		// load game pieces
		this.load.spritesheet("tactics", "assets/sprites/tiles.png", {
            frameWidth: GAMEAPP.tileSize,
            frameHeight: GAMEAPP.tileSize
        });
		this.load.image("hud", "assets/sprites/scoreBar.png", {
            frameWidth: config.width,
            frameHeight: 60
        });
		
    },
    // ---------------------------------------------------------
    create(){
        this.add.image(0, 0, 'playBG').setOrigin(0);
        this.input.once('pointerdown', function () {
            console.log('From playGame to menu');
            this.scene.start('menu');

        }, this);
    }

});
