/**
 * 
 * SINGLE PLAYER OPMTIMIZED FSM MENUS
 * 
 * Copyright © 1990-2016, Stephen Gose LLC. All rights reserved.
 * Visit our game show case:	https://www.renown-games.com 
 * License information:		https://shop.pbmcube.net/downloads/adventurers-of-renown-blood-pit/
 * Affiliate Information:		https://www.stephen-gose.com/products/affiliates-program/
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
 * THE SOFTWARE.
 * 
 *
 * File Name: exitGame.js
 * Live Demo:	https://makingbrowsergames.com/p3gp-book/_p3-bloodPitv1/
 * Source Code: https://makingbrowsergames.com/book/
 * Description: File for controlling game exit and gargabe collection.
 * Author: Stephen Gose
 * Version: 0.0.0.19971027-1  //semantic version: by (0.0.0.date-#)
 * Phaser Version: 3.15.x+
 * Author URL: https://www.stephen-gose.com/
 * Support: support@pbmcube.com
 *
 * \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
 * Redistribution of part or whole of this file and
 *   the accompanying files is strictly prohibited.
 * 
 * Do not sell! Do not distribute!  
 *  Please refer to the Terms of Use and 
 *    End Users License Agreement (EULA).
 *  This is a licensed file with EULA permission. 
 *  
 * Search for "//**TODO**" to tailor this file for your production; 
 *	 doing so will void any support agreement.
 *
 */
	"use strict";
	// desired dynamic menu button labels	
var exitMnuTxt = ["Inventory","Exit","Submit","Save","Share","Next"];
	// assigned and deployed to menu buttons
var labelTxt = ["","","","","",""];
	// menu button sprites
var exitMnuBtn = [{},{},{},{},{},{}];

	window.GAMEAPP.state.exitGame = {
		preload: function(){
			console.log("loading Exit Game state");
			GAMEAPP.CrntRoom = GAMEAPP.Logout;
			this.load.image('exitGame', 'assets/images/staticRooms/intro.jpg');
			
		},
		
		create: function(){
			console.log("starting Exit Game state");
			this.add.image(0, 0, 'exitGame').setOrigin(0);
						
			// =========================================================
			// Phaser III ARRA Character Death animation - commented out!
			this.ARRADeath = this.add.sprite(1600, 212, 'Death');
			//  Here we add a new animation called 'die'
			//  Because we didn't give any other parameters it's going to make an animation 
			//    from all available frames in the ARRA Death sprite sheet
			this.anims.create({
				  key: 'die',
				  frames: this.anims.generateFrameNumbers('Death', { start: 0, end: 11 }),
				  frameRate: 10,	//  10 is the frame rate (10fps)
				  repeat: -1		//  -1 means it will loop when it finishes
				});
			// And this starts the animation playing by using its key ("die")
			// 	animation is actively running "off stage"
			this.ARRADeath.anims.play('die');
			// =========================================================
			var endText = "This is the end of the sample In-Game Module.\nYou can learn how this was created\n from the newly released book\nGame Prototyping with Phaser\n Available on Amazon or LeanPub.com";
			
			// 1st Row - Inventory button 
			exitMnuBtn[0] = this.add.sprite( 65, 313, 'button').setInteractive();
			// 1st Row - Submit Score button 
			exitMnuBtn[1] = this.add.sprite(152, 313, 'button').setInteractive();
			// 1st Row - New Game? button 
			exitMnuBtn[2] = this.add.sprite(240, 313, 'button').setInteractive();
			// 2nd row - Exit button 
			exitMnuBtn[3] = this.add.sprite( 65, 336, 'button').setInteractive();
			// 2nd row - Save button 
			exitMnuBtn[4] = this.add.sprite(152, 336, 'button').setInteractive();
			// 2nd row - Share button 
			exitMnuBtn[5] = this.add.sprite(240, 336, 'button').setInteractive();
			
			//take each button and create addition parameters
			exitMnuBtn.forEach( function (key, index) {
				key.name = exitMnuTxt[index];	// button name
				key.setFrame(1);				// set initial frame
				key.setScale(0.7,0.7);			// scale size
				key.enableBody = true;			// make click-able
				// debug & interactions
				key.on('pointerover',function (pointer){console.info(key.name + " over. ");key.setFrame(0);}, this);
				key.on('pointerout',function (pointer){console.info(key.name + " off. ");key.setFrame(1);}, this);
				key.on('pointerdown',function (pointer){console.info(key.name + " clicked.\n (inactive in demo)");key.setFrame(2);}, this);
				key.on('pointerup',function (pointer, key){ 
					console.info(exitMnuTxt[index] + " released. (inactive in demo)\n Submitted: "+exitMnuTxt[index]);
					
					// NEW Phaser III scene.transition feature
					this.scene.transition({
						target: exitMnuTxt[index],	// the next Scene key to transition into
						moveBelow: true,			// move the target Scene below this current  
													// 	scene before the transition starts
						duration: 100,				// delay processing duration in ms
						sleep: false,				// true = to sleep current scene;   
													// false = to stop current scene
						allowInput: false,			// true = to enable input system of current  
													//	scene and target scene
						onUpdateScope: exitMnuTxt[index]
					});}, this);

				// insert button labels from source array
				if(index < 3){
					labelTxt[index] = this.add.text(65+(87*index),313, exitMnuTxt[index], GAMEAPP.styleBTN);
					labelTxt[index].setOrigin(0.5,0.5);
				}else{
					if(index==exitMnuTxt.length){
						labelTxt[index] = this.add.text(65+(87*(index-3)),336, "New Game?", GAMEAPP.styleBTN);
					}else{
						labelTxt[index] = this.add.text(65+(87*(index-3)),336, exitMnuTxt[index], GAMEAPP.styleBTN);
					}
					labelTxt[index].setOrigin(0.5,0.5);
				}
			}, this);	// End menu factory
			console.table(exitMnuBtn);
			
			this.ending = this.add.text(config.width/2,config.height/2,endText,GAMEAPP.styleBTN);
			this.ending.setOrigin(0.5,0.5);
			this._toolTip = this.add.text(config.width-100, 313, GAMEAPP.InfoText, GAMEAPP.styleTT);
			this._toolTip.setOrigin(0.5);
			GAMEAPP.InfoText = "Experience & Score: "+String(CCP.Score)+"\n Renown Earned: "+String(CCP.Renown);
			GAMEAPP.RoomAlert = "Quest failed!";
			
			// rv_5 (AJAX MMoG)
			// Send update to server as a "heart beat / keep alive"
			// TXBuffer();
			// Heart.send("update.asp",POST);
			
			// rv_8 (RPC MMoG)
			// IBPrpArcade game scores enabled
			var gname="ARRA-PBMCube";
			var pname = CCP.Name;
			var gscore = CCP.Renown;
			// getURL("index.php?act=Arcade&do=newscore", "_blank", "POST");
			
		},
		
		update: function(){
			this._toolTip.setText(GAMEAPP.InfoText);

		},
		
		transitionOut: function(progress){
			// NO OPERATION
		},	// place " , " If using more supporting function below
		
		//
		// =========================================================
		Inventory: function(){
			
			// debug
			console.log("Room #: Exit defeated; Inventory Clicked: ");
			// works 100%
			this.scene.stop();	// default reference to current scene.
			this.game.scene.start('Inventory');	//Inventory Scene rv_3 to rv_8
			
		},
		//
		// =========================================================
		Next: function(){
			// Refer to Phaser Multi-Player Gaming Systems server-side middleware
		/**
			// Membership Only version follows
			// debug
			console.log("Room #: Exit defeated; New Game Clicked: ");
			console.log(' - Equip ALL Monsters in Database once per game.');
			GAMEAPP._MonsterPrep();
			GAMEAPP._AllotMonster();
			
			console.log(' - Creating internal static Monster Database:');
			console.table(M);
			
			GAMEAPP._AllotTreasure();
			console.table(MT);
			
			this.scene.stop();
			this.game.scene.start('boot');	//Return to Boot/Preload Scenes
		*/
		
			// Demo version only
			// restarts everything new
			window.open("https://makingbrowsergames.com/p3gp-book/_p3-bloodPitv1/", "_blank");
		},
		//
		// =========================================================
		Save: function(){
			//Refer to book Bonus Content server-side middleware
			//debug
			console.log("Save Clicked: (inactive in demo)");
		},
		//
		// =========================================================
		Share: function(){
			//Refer to book Bonus Content server-side middleware
			//debug
			console.log("Share Clicked: (inactive in demo)");
		},
		//
		// =========================================================
		Submit: function(){
			//Refer to book Bonus Content server-side middleware
			//debug
			console.log("Submit Score Clicked: (inactive in demo)");
		}
	};