/**
* Copyright © 1997-2016, Stephen Gose LLC. All rights reserved.
* Visit our game show case:     https://www.renown-games.com 
* License information:          https://leanpub.com/mbg-memory
* Affiliate Information:		https://www.stephen-gose.com/affiliates-program
*
* The above copyright notice and this permission notice shall be included in 
* all copies or substantial portions of the Software.
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER  
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN  
* THE SOFTWARE.
*
*
* File Name:    menu.js
* License:		https://makingbrowsergames.com/starterkits/LICENSE.pdf
* Live Demo:    <> 
* Source Code:  https://makingbrowsergames.com/book/
* Description: File for controlling and displaying game menu phase; 
*		managing some global variables throughout game state 
*		in the gaming shell.
* Author: Stephen Gose
* Version: 0.0.0.xx
* Phaser Version: 3.24+
* Author URL:   https://www.stephen-gose.com/
* Support: support@pbmcube.com
*
* \u00A9 Copyright ©  1974-2017 Stephen Gose LLC. All rights reserved. 
* 
* Do not sell! Do not distribute!
* This is a licensed file with EULA permission.
* Please refer to the Terms of Use
*   and End Users License Agreement (EULA).
*  
* Search for [ //TODO ] to tailor this file for your own use; 
*	 doing so will void any support agreement.
*
* Redistribution of part or whole of this file and
* the accompanying files is strictly prohibited.
*
* This file is automatically loaded from state/load.js
* to change default state - change state/load.js at line: 34
*
* Reference: 
* https://labs.phaser.io/edit.html?src=src\scenes\tutorial\scene%20controller.js
* https://labs.phaser.io/edit.html?src=src\scenes\changing%20scene.js
* https://www.html5gamedevs.com/topic/37199-extending-phaser-classes-es6-syntax-vs-phaserclass-differences/
* 
*/
// =========================================================
"use strict";
/**	game main menu **/
window.GAMEAPP.state.menu = {
	preload: function(){
		console.log(" %c xxxx rv_18 Game Prototype Main Menu ", "color:white; background:red");
		GAMEAPP.InfoText = "Main Menu Selections";
		//BGTTT mainMenu & Story collapse into one scene
		GAMEAPP._assignLanguage(GAMEAPP.gameLanguage);

	},
	
	create: function(){
		console.log("starting story line & Main Menu state");
		this.input.setGlobalTopOnly(true);
		this.add.image(config.width/2, config.height/2, 'mainMenu');		
		var style = {};

		if (GAMEAPP.gameLanguage == 0) {
			
			style = { font: "12px Arial", fill: "#F90", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 245 };
			this.introParatxt = this.add.text(config.width/3,config.height -150, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			//this.introParatxt.setTextBounds(555, 70, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}else{
			
			// the alignment of the text is independent of the bounds, try changing to 'center' or 'right'
			style = { font: "14px Arial", fill: "#F00", align: "center", boundsAlignH: "left", boundsAlignV: "top", wordWrap: true, wordWrapWidth: 230 };
			this.introParatxt = this.add.text(config.width/3,config.height -150, GAMEAPP.introPara, style);
			this.introParatxt.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
			//this.introParatxt.setTextBounds(550, 138, 780, 400);
			this.introParatxt.fontWeight = 'bold';
		}
		
		//Main Menu creation
		//this.soundButton = this.add.button(10, 10, 'soundButton', this.toggleThemeMusic, this);
		
		// Play 
		this.playButton = this.add.sprite(670, 330, 'button').setInteractive();
		this.playButton.setFrame(1);
		this.playButton.setOrigin(0.5,0);
		this.playButton.setScale(0.7,0.7);
		this.playButton.name = "play";

this.playButton.on('pointerover', function (pointer){
    console.info(this.playButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.playtxt);
    this.playButton.setFrame(2);
}, this);
this.playButton.on('pointerout', function (pointer){
    console.info(this.playButton.name + " out. ");
    this._toolTip.setText(""); 
    this.playButton.setFrame(1);
}, this);
this.playButton.on('pointerdown',  function (pointer){
    console.info(this.playButton.name + " clicked down. ");
    this.playButton.setFrame(0);
}, this);
this.playButton.on('pointerup',  function (pointer){
    console.log(this.playButton.name + " click released.");
    //startGame();
    console.log("Play selected");
    this.playButton.setFrame(1);
    this.scene.transition({
            //target: "story",    // goes to story line
            //target: "menu",
            //target: "credits",
            target: "play",
            duration: 150,
            sleep: false,		// true = to sleep current scene;   
                                // false = to stop current scene
            moveAbove: true,	// move the target Scene above this current  
                                // 	scene before the transition starts
            moveBelow: false,	// move the target Scene below this current  
            //onUpdate: GameReturn(),
            
            //onUpdateScope: "story"
            //onUpdateScope: "credit"
            onUpdateScope: "play"
    });
    
}, this);
var playtxt = this.add.text(653, 330, "Play" , { font: "18px Arial", fill: "#000000", align: "center" });	// "Play";
		
		// Credit 
		this.creditButton = this.add.sprite(610, 370, 'button').setInteractive();
		this.creditButton.setFrame(1);
		this.creditButton.setOrigin(0.5,0);
		this.creditButton.setScale(0.7,0.7);
		this.creditButton.name = "credit";
		
this.creditButton.on('pointerover', function (pointer){
    console.info(this.creditButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.credittxt); 
    this.creditButton.setFrame(2);
}, this);
this.creditButton.on('pointerout', function (pointer){
    console.info(this.creditButton.name + " out. ");
    this._toolTip.setText(""); 
    this.creditButton.setFrame(1);
}, this);
this.creditButton.on('pointerdown',  function (pointer){
    console.info(this.creditButton.name + " clicked down. ");
    this.creditButton.setFrame(0);
}, this);
this.creditButton.on('pointerup',  function (pointer){
    console.log(this.creditButton.name + " click released.");
    //GameCredits();
    this.creditButton.setFrame(1);
        console.log(this.creditButton.name + " click released.");
        this.creditButton.setFrame(2);
        this.scene.transition({
                //target: "story",    // goes to story line
                //target: "menu",
                target: "credits",
                duration: 150,
                sleep: false,		// true = to sleep current scene;   
                                    // false = to stop current scene
                moveAbove: true,	// move the target Scene above this current  
                                    // 	scene before the transition starts
                moveBelow: false,	// move the target Scene below this current  
                //onUpdate: GameReturn(),
                
                //onUpdateScope: "story"
                onUpdateScope: "credits"
            });
        }, this);

var credittxt = this.add.text(585, 370, "Credits", { font: "18px Arial", fill: "#000000", align: "center" });	
	
		// Share - external
		this.shareButton = this.add.sprite(610, 410, 'button').setInteractive();
		this.shareButton.setFrame(1);
		this.shareButton.setOrigin(0.5,0);
		this.shareButton.setScale(0.7,0.7);
		this.shareButton.name = "share";
		
this.shareButton.on('pointerover', function (pointer){
    console.info(this.shareButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.sharetxt); 
    this.shareButton.setFrame(2);
}, this);
this.shareButton.on('pointerout', function (pointer){
    console.info(this.shareButton.name + " out. ");
    this._toolTip.setText(""); 
    this.shareButton.setFrame(1);
}, this);
this.shareButton.on('pointerdown',  function (pointer){
    console.info(this.shareButton.name + " clicked down. ");
    this.shareButton.setFrame(0);
}, this);
this.shareButton.on('pointerup',  function (pointer){
    console.log(this.shareButton.name + " click released.");
    GameShare();
    this.shareButton.setFrame(1);
}, this);
var sharetxt =  this.add.text(588, 410, "Share", { font: "18px Arial", fill: "#000000", align: "center" });
		
		// Game Options : Language Selection
		this.optButton = this.add.sprite(610, 450, 'button').setInteractive();
		this.optButton.setFrame(1);
		this.optButton.setOrigin(0.5,0);
		this.optButton.setScale(0.7,0.7);
		this.optButton.name = "options";
		
this.optButton.on('pointerover', function (pointer){
    console.info(this.optButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.opttxt); 
    this.optButton.setFrame(2);
}, this);
this.optButton.on('pointerout', function (pointer){
    console.info(this.optButton.name + " out. ");
    this._toolTip.setText(""); 
    this.optButton.setFrame(1);
}, this);
this.optButton.on('pointerdown',  function (pointer){
    console.info(this.optButton.name + " clicked down. ");
    this.optButton.setFrame(0);
}, this);
this.optButton.on('pointerup',  function (pointer){
    console.log(this.optButton.name + " click released.");
    // GameOptions();
    this.optButton.setFrame(1);
        this.scene.transition({
                //target: "story",    // goes to story line
                //target: "menu",
                //target: "credits",
                target: "language",
                duration: 150,
                sleep: false,		// true = to sleep current scene;   
                                    // false = to stop current scene
                moveAbove: true,	// move the target Scene above this current  
                                    // 	scene before the transition starts
                moveBelow: false,	// move the target Scene below this current  
                //onUpdate: GameReturn(),
                
                //onUpdateScope: "story"
                //onUpdateScope: "credit"
                onUpdateScope: "language"
            });
}, this);
    
var opttxt = this.add.text(583, 450, "Options", { font: "18px Arial", fill: "#000000", align: "center" });

		// More Games - external 
		this.moreButton = this.add.sprite(735, 370, 'button').setInteractive();
		this.moreButton.setOrigin(0.5,0);
		this.moreButton.setFrame(1);
		this.moreButton.setScale(0.7,0.7);
		this.moreButton.name = "more";
		
this.moreButton.on('pointerover', function (pointer){
    console.info(this.moreButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.moretxt); 
    this.moreButton.setFrame(2);
}, this);
this.moreButton.on('pointerout', function (pointer){
    console.info(this.moreButton.name + " out. ");
    this._toolTip.setText(""); 
    this.moreButton.setFrame(1);
}, this);
this.moreButton.on('pointerdown',  function (pointer){
    console.info(this.moreButton.name + " clicked down. ");
    this.moreButton.setFrame(0);
}, this);
this.moreButton.on('pointerup',  function (pointer){
    console.log(this.moreButton.name + " click released.");
    MoreGame();
    this.moreButton.setFrame(1);
}, this);
var moretxt = this.add.text(713, 370, "More", { font: "18px Arial", fill: "#000000", align: "center" });
		
        // Web Masters & customer License - external 
		this.webButton = this.add.sprite(735, 410, 'button').setInteractive();
		this.webButton.setFrame(1);
		this.webButton.setOrigin(0.5,0);
		this.webButton.setScale(0.7,0.7);
		this.webButton.name = "web";
		
this.webButton.on('pointerover', function (pointer){
    console.info(this.webButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.webtxt); 
    this.webButton.setFrame(2);
}, this);
this.webButton.on('pointerout', function (pointer){
    console.info(this.webButton.name + " out. ");
    this._toolTip.setText(""); 
    this.webButton.setFrame(1);
}, this);
this.webButton.on('pointerdown',  function (pointer){
    console.info(this.webButton.name + " clicked down. ");
    this.webButton.setFrame(0);
}, this);
this.webButton.on('pointerup',  function (pointer){
    console.log(this.webButton.name + " click released.");
    WebMaster();
    this.webButton.setFrame(1);
}, this);
var webtxt = this.add.text(707, 410, "License", { font: "18px Arial", fill: "#000000", align: "center" });

		// Donation Link - external
		this.donaButton = this.add.sprite(735, 450, 'button').setInteractive();
		this.donaButton.setFrame(1);
		this.donaButton.setOrigin(0.5,0);
		this.donaButton.setScale(0.7,0.7);
		this.donaButton.name = "dona";
		
this.donaButton.on('pointerover', function (pointer){
    console.info(this.donaButton.name + " over. ");
    this._toolTip.setText(GAMEAPP.donatxt); 
    this.donaButton.setFrame(2);
}, this);
this.donaButton.on('pointerout', function (pointer){
    console.info(this.donaButton.name + " out. ");
    this._toolTip.setText(""); 
    this.donaButton.setFrame(1);
}, this);
this.donaButton.on('pointerdown',  function (pointer){
    console.info(this.donaButton.name + " clicked down. ");
    this.donaButton.setFrame(0);
}, this);
this.donaButton.on('pointerup',  function (pointer){
    console.log(this.donaButton.name + " click released.");
    GameDonations();
    this.donaButton.setFrame(1);
}, this);
var donationtxt = this.add.text(696, 450, "   How?!", { font: "18px Arial", fill: "#000000", align: "center" });

	this._toolTip = this.add.text(670, config.height/2+50, GAMEAPP.InfoText, GAMEAPP.styleHUD);
	this._toolTip.setOrigin(0.5,0.5);
	this._toolTip.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
	this._toolTip.fontWeight = 'bold';

	//this.camera.flash(0x000000, 500, false);
    

    //Game Title stored in Phaser3 game.config
    // this.gTitle = this.add.text(config.width/2,config.height/2-180, GAMEAPP.gameTitle, GAMEAPP.styleTitle);
    this.gTitle = this.add.text(config.width/2,config.height/2-180, GAMEAPP.gameTitle, GAMEAPP.styleHUD2);
    this.gTitle.setOrigin(0.5,0.5);
    this.gTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
    this.gTitle.fontWeight = 'bold';
    //-----
    //Game SubTitle stored in Phaser3 game.config
    this.gSubTitle = this.add.text(config.width/2,config.height/2-130, GAMEAPP.subTitle, GAMEAPP.styleSubTitle);
    this.gSubTitle.setOrigin(0.5,0.5);
    this.gSubTitle.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);
    //-----
    //Setup Copyright notice:
    // create dynamically updated year on notice
    var d = new Date();			//get JavaScript Date
    var n = d.getFullYear();	//get full year
    //Design Note: ( C ) is NOT a legal copyright notice
    // read more on proper copyright notices in
    // Phaser Game Design Workbook available at
    // https://leanpub.com/phaserjsgamedesignworkbook
    var Copr = this.add.text(config.width/2, config.height-20,"Copyright \u00A9 1974-"+n+", Stephen Gose. All rights reserved.\n Mozart Music Match™ is a service mark of Stephen Gose LLC.",GAMEAPP.styleCopr);
    Copr.setOrigin(0.5, 0.5);
    Copr.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);

		
	},
	
	update: function(){
		
	}	//place " , " If using more supporting function below
	
};	

function startGame (pointer) {
  //	And start the actual game
  // https://phaser.io/phaser3/devlog/121
  // https://phaser.io/phaser3/devlog/119
  // fade camera in Phaser III
  //this.cameras.main.fade(1500, 255, 255, 255);
  // restart game in Phaser III
  //this.cameras.main.on('camerafadeoutcomplete', function () {
  console.log("Game Play launched.");
  GAMEAPP.game.scene.stop("menu").sendToBack();
  GAMEAPP.game.scene.start('game').bringToTop();
  //}, this);
}
/* function GameCredits (pointer) {
  // fade camera in Phaser III
  //this.cameras.main.fade(1500, 255, 255, 255);
  // restart game in Phaser III
  //this.cameras.main.on('camerafadeoutcomplete', function () {
  console.log("Game Credits launched.");
  GAMEAPP.game.scene.stop("menu").sendToBack();
  GAMEAPP.game.scene.start('credits').bringToTop();
  //}, this);
}
*/

/* function GameOptions (pointer) {
  // fade camera in Phaser III
  //this.cameras.main.fade(1500, 255, 255, 255);
  // restart game in Phaser III
  //this.cameras.main.on('camerafadeoutcomplete', function () {
  console.log("Game Options launched.");
  GAMEAPP.game.scene.stop("menu").sendToBack();
  GAMEAPP.game.scene.start('language').bringToTop();
  //}, this);
}
*/	
	//uses right-side plugin
function GameShare (pointer) {
		//Popup twitter window 
		var game_url = 'https://makingbrowsergames.com/starterkits/';
		var twitter_name = 'PBMCube';
		var tags = ['Phaser,phaser3'];
		
		//Ok, gamer want to share with friends; let's use twitter.
		window.open('https://twiter.com/share?text=I+am+creating+and+playing+fun+games+from+&via='+twitter_name+'&url='+game_url+'&hashtags='+tags.join(','), '_blank');
}
	
function MoreGame(pointer) {
		//	And start the actual game
		//originally moved to separate internal scene; now off-site
		window.open("https://www.renown-games.com./index.html", "_blank");

}

function WebMaster(pointer) {
		//	And start the actual game
		//originally moved to separate internal scene; now off-site
		//window.open("https://shop.pbmcube.net/downloads/category/software-source-code/ssc5/", "_blank");
		window.open("https://leanpub.com/p3gskc", "_blank");

}

function GameDonations (pointer) {

		//	And start the actual game
		//originally moved to separate internal scene; now off-site
		//window.open("https://www.paypal.me/pbmcube", "_blank");
		window.open("https://leanpub.com/p3gskc", "_blank");
}

/* End of file */
/*  Location: /js/states/menu.js  */